// ts401.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <windows.h>


//////////////////////////////////////////////////////////////////////////////
//added lib of MP401
#pragma comment(lib,"mp401.lib")

#include "mp401.h"



HANDLE hDevice=INVALID_HANDLE_VALUE;


int main(int argc, char* argv[])
{
	
	int i=0;
	int j=0;
	char a[80];

	
		//open device
	printf("Open Device Mp401........");

	hDevice=MP401_OpenDevice(0);

	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		printf("error open USB Deivce\n");
		Beep(1000,300);
		getch();
		exit(0);
	}
    else
	{  
		printf("Device Num:%d\n",hDevice);
	}
	
   

  	

    //get info of Mp401
    i=MP401_Info(hDevice,a);
	printf("Mp401's Board Design Infomation:%s\n",a);



    i=0xaa;	
	printf("Set DO=%x     ",i);
	MP401_DO(hDevice,i);

	//di
	printf("read DI=%x\n",MP401_DI(hDevice));

	i=0x55;	
	printf("Set DO=%x     ",i);
	MP401_DO(hDevice,i);

	//di
	printf("read DI=%x\n",MP401_DI(hDevice));

    


    printf("set DA0=10V........\n");
	MP401_DA(hDevice,0,4095);
    
	printf("set DA1=5V........\n");
	MP401_DA(hDevice,1,2048);
    
	getch();

	
	printf("set DA0=5V........\n");
	MP401_DA(hDevice,0,2047);
    
	printf("set DA1=10V........\n");
	MP401_DA(hDevice,1,4095);
    
	getch();


	
    printf("\nTesting AD\n");
    
	long ercnt=0;
	double max=-5000.0;
	double min=5000.0;

    //set ch=0; speed=80
	long ch=0;
	long sidi=0;
	long sp=0;
	long gs=2;
    long addata=0;
    long caldata=0; //temp buffer for cal data
    long cald[3]; //temp buffer for cal data
    
	int cnt=0;
    
	double v=0;
    double gain=0;

	MP401_ADSET(hDevice,ch,gs,sp);
     
	   //test cal
	   MP401_CAL(hDevice);

       //if end
	   do{
		   cnt++;
		   Sleep(10);
		   i=MP401_CALPOLL(hDevice);
		   
	   }while(i!=0);

    printf("CAL Delay=%d mS    Speed:%d\n",cnt*10,sp);



	

	
    //setting
	printf("Setting time.......\n");
	
	MP401_ADSET(hDevice,7,gs,sp);
	Sleep(200);
    
	MP401_ADSET(hDevice,ch,gs,sp);
    MP401_ADDELAY(hDevice);
	
	for(j=0;j<8;j++)
    {

        MP401_ADRUN(hDevice);

		while(MP401_ADREAD(hDevice,&addata)!=0);

        printf("%10d",addata);
	}

	printf("\n");

	
	
	
	getch();


	gs=0;
	ch=0;
	sp=0;

	
	
	switch(gs)
	{
	case 0:
		gain=1;
		break;
   
	case 1:
		gain=2;
		break;

    case 2:
		gain=64;
		break;

   case 3:
		gain=128;
		break;


	}


    printf("gain=%3.0f\n",gain);

	
	

	//set cal data
    //set ch=7
	
	cald[2]=MP401_CALZD(hDevice,2,sp);
	printf("G2 cal read=%d  %x\n",cald[2],cald[2]);
	
    cald[1]=MP401_CALZD(hDevice,1,sp);
	printf("G1 cal read=%d  %x\n",cald[1],cald[1]);
	




	MP401_ADSET(hDevice,ch,gs,sp);
	//MP401_ADDELAY(hDevice);

	MP401_CAL(hDevice);
	//if cal end
	while(MP401_CALPOLL(hDevice)!=0);
    
	
	getch();

	max=-5000;
	min=5000;
	
do{
	do{
	    
		MP401_ADRUN(hDevice);	
		while(MP401_ADREAD(hDevice,&addata)!=0);
	
        //for cal data
		//addata=(gs<2) ? addata : addata-caldata;
        switch(gs)
		{
		   case 0:
               {
				   addata=addata;
				   break;}

		   case 1:
			   {addata=addata-cald[1];
			   break;}
            
		   case 2:
			   {addata=addata-cald[2];
			   break;}



		}


		v=(double)(addata-0x7fffff)*5000.0/(double)0x800000;
		v=v/gain;

	  cnt++;

	  if(cnt<100)
	  {
		max=(v>max) ? v : max;
		min=(v<min) ? v : min;
      }
	  
	


	  
		//read ad
	    printf("G=%d data=%10d %10x v=%8.4fmV  er=%10d  delta:%8.4f\n",gs,addata,addata,v,ercnt,(max-min));

		if(cnt>=100)
		{
           max=-5000;
           min=-max;
		   cnt=0;
		}
		
		//MP401_outb(hDevice,1,0);

		Sleep(1);

        if(abs(i)>5000)
		{
			 ercnt++;
			// getch();
		}


    }while(!kbhit());

    i=getch();

	if(i=='c')
	{
		caldata=MP401_CAL(hDevice);
		ercnt=0;
		max=-5000;
		min=-max;
	}


    if(i=='g')
	{
	   
		gs++;

		gs=gs & 3;
		if(gs>2)
			gs=0;

		
        MP401_ADSET(hDevice,ch,gs,sp);
		MP401_CAL(hDevice);
		while(MP401_CALPOLL(hDevice)!=0);
		
		
		switch(gs)
		{
		case 0:
			gain=1;
			break;
   
		case 1:
			gain=2;
			break;

		case 2:
			gain=64;
			break;

	   case 3:
			gain=128;
			break;


	}




	}



}while(i!=27);


  
	getch();
	MP401_CloseDevice(hDevice);

  return 0;
}